Bug 38244 - Enable attaching comments to document text ranges in Writer (Notes Anchor Area, OOoNotes2) [UI] [VIEWING]
Summary: Enable attaching comments to document text ranges in Writer (Notes Anchor Are...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium enhancement
Assignee: Miklos Vajna
QA Contact:
URL:
Whiteboard: target:4.0.0
Keywords:
: 35383 36015 43885 45301 47055 54004 59743 68672 (view as bug list)
Depends on:
Blocks: 53442
  Show dependency treegraph
 
Reported: 2011-06-13 06:23 UTC by Christoph
Modified: 2015-10-05 14:40 UTC (History)
14 users (show)

See Also:
Crash report or crash signature:


Attachments
This file contains an example of the problem of hidden codes making it hard to edit (14.08 KB, application/vnd.oasis.opendocument.text)
2014-02-19 20:59 UTC, Jon Hayes
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Christoph 2011-06-13 06:23:25 UTC
Issue: Comments/notes in Writer can not be attached to strings (e.g. words, several paragraphs). At the moment, they can only be inserted and represent a special character. This makes reviewing of documents pretty hard for users, and restricts exchanging documents with user of e.g. Microsoft Word. ==> highly desired feature for users (e.g. [1])

Current status:
* ODF should support comment ranges (but should be checked)
* All required specifications are available
* This enhancement is related to the OOo activity "Notes2" [2]

Required changes:
* Add capability to highlight ranges in text documents (see [2])
* Implement behavior when text related to notes ranges are edited (see [3])
* Import / export capability with other formats (like Microsoft Word)
* Desired: Improve highlighting of today's notes anchors

Contact: Christoph Noack (Design Team)


References:
[1] Example user request
http://www.mail-archive.com/discuss@documentfoundation.org/msg06764.html

[2] Notes2 - Improved Notes for OOo
http://wiki.services.openoffice.org/wiki/Notes2

[3] Spec: highlighting of comment ranges
http://wiki.services.openoffice.org/wiki/Notes2_Design_NoteAnchor#Proposal_.22Boxes_.28Note_Anchor_Area.29.22

[4] Spec: behavior when editing text (see Proposal "Inserting a Note" #1 ("SmartAnchor"))
http://wiki.services.openoffice.org/wiki/Notes_Design_WorkingWithNotes#Proposed_Designs
Comment 1 gleppert 2011-07-09 10:38:20 UTC
@Christoph: Isn't this a duplicate of bug 36015? If so, could you please merge both bug entries?

Please also have a look at: http://wiki.documentfoundation.org/Track_changes
Comment 2 Christoph 2011-07-10 14:28:43 UTC
Add author of issue 36015 as CC.
Comment 3 Christoph 2011-07-10 14:28:53 UTC
*** Bug 36015 has been marked as a duplicate of this bug. ***
Comment 4 gleppert 2011-07-23 10:34:27 UTC
*** Bug 35383 has been marked as a duplicate of this bug. ***
Comment 5 gleppert 2011-07-23 10:39:28 UTC
Having marked bug 35383 as duplicate of this one, because this bug entry here contains more information. Also added one member of the CC list of bug 35383 to this one here.

The related and 7 year old bug entry from OpenOffice.org: http://openoffice.org/bugzilla/show_bug.cgi?id=5487
Comment 6 GerardF 2012-01-27 06:59:08 UTC
*** Bug 45301 has been marked as a duplicate of this bug. ***
Comment 7 vitriol 2012-03-07 07:18:08 UTC
*** Bug 47055 has been marked as a duplicate of this bug. ***
Comment 8 Moritz Moeller-Herrmann 2012-04-10 04:14:30 UTC
*** Bug 43885 has been marked as a duplicate of this bug. ***
Comment 9 Miklos Vajna 2012-07-16 07:42:35 UTC
I started working on this, I expect I'll have something usable in master by 2012-07-20.
Comment 10 gleppert 2012-07-17 06:10:44 UTC
@Miklos: Thanks for working on this enhancement. I am looking very much forward to it :-)
Comment 11 Moritz Moeller-Herrmann 2012-07-17 07:45:17 UTC
I would also like to express my gratitude for your efforts - this is really holding back Writer as a tool to work on legal documents if others use Word. Thank you very much in advance - if there is anything I (as a lawyer) can do to help, please let me know.
Comment 12 Not Assigned 2012-07-17 07:58:20 UTC
Miklos Vajna committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=acaa4d592a0d8cc219f7ec8a65b0c17757a856aa

fdo#38244 enable attaching comments to document text ranges in writer
Comment 13 Not Assigned 2012-07-18 10:01:35 UTC
Miklos Vajna committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=b8146f5126e8290b5b287f0a6176ff6619f34f67

fdo#38244 testcase
Comment 14 Gerry 2012-07-18 10:16:14 UTC
@Miklos: Does it really mean that you implemented this feature already? That's great news! Thank you very much!
Comment 15 Not Assigned 2012-07-18 10:42:17 UTC
Miklos Vajna committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/help/commit/?id=3cacadc5c9e6a0780a4c75cd3614eddc8db8e933

fdo#38244 update comment insertion help
Comment 16 Not Assigned 2012-07-18 16:29:10 UTC
Caolan McNamara committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=165640076df65971eb01f887a3c285cd6eb61d94

Related: fdo#38244 include ODF_COMMENTRANGE in annotation undo/redo
Comment 17 Miklos Vajna 2012-07-19 05:43:17 UTC
Hi Gerry,

Almost - the ODF import/export still uses nonstandard tags, I first wanted to fix that up before commenting here that the feature is ready. ;-)

Miklos
Comment 18 Moritz Moeller-Herrmann 2012-07-20 08:31:30 UTC
Hi Miklos,

will you also deal with doc and docx import/export? That would make the feature perfect. 

I assume you are working on this for SuSe, right?

Many thanks for your efforts!
Comment 19 Not Assigned 2012-07-20 13:46:03 UTC
Miklos Vajna committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=c251673851b72c3b516dee6db44f1e7a8854aeb9

fdo#38244 comment range odf import/export testcase
Comment 20 Miklos Vajna 2012-07-20 13:50:41 UTC
Hi Moritz,

odf, docx and rtf import/export is implemented in master. doc is missing, but should not be hard to do, provided one is familiar with that format.

And yes, my employer is hopefully clear from the mail address. :-)

Miklos
Comment 21 Miklos Vajna 2012-07-20 13:58:28 UTC
This feature now should be implemented in master, marking as resolved.
Comment 22 Olivier R. 2012-07-23 10:55:23 UTC
Thanks Miklos for this feature.

Tested in Version 3.7.0.0.alpha0+ (Build ID: 4b2d5d7) on Windows 7.

BUGS:
When double-clicking in a comment range, you select the full text range instead of the word you click on.
When triple-clicking in a comment range, you select the first sentence on the comment range instead of the sentence you click on.

Should we open new issues for bugs concerning this feature? Or this place is still OK while it’s still in development?
Comment 23 Miklos Vajna 2012-07-30 08:06:13 UTC
Hi Oliver,

Yes, please open a separate bug for that problem, and add me to CC, then I'll try to have a look.

Thanks,

Miklos
Comment 24 Olivier R. 2012-07-30 10:16:07 UTC
Text selection bug:
https://bugs.freedesktop.org/show_bug.cgi?id=52960
Comment 25 Alexandre Demers 2012-08-10 17:57:15 UTC
Miklos, you've reported "Finally, one known limitation is that the text range currently can’t include multiple paragraphs — something to improve later if necessary." on your blog. Is there a reason for this limitation? Is the work to fix this limitation important? According to ODF 1.2, I don't see any technical restriction not to have it.

I don't see any comment in the patches you've submitted about this limitation. I may have missed it, but otherwise it should be documented for future improvement.

In all, your work is great and really helpful. My only concern is with the fact it doesn't cover multi-paragraphs while it was a point in the description reported by Christoph "Issue: Comments/notes in Writer can not be attached to strings (e.g. words, several paragraphs).". Thus, I'm not sure the current bug should marked as Resolved/Fixed.
Comment 26 Miklos Vajna 2012-08-13 15:55:46 UTC
Hi Alexandre,

You're right, I don't think the ODF spec limits the text range to a single paragraph, either. I mentioned that limitation as right now I don't have time to implement that -- I hope either I'll have in the near future, or someone else will find that an interesting feature to hack on.

I suggested already to have a bug for that, so it won't be forgotton. In general, we believe that one bug should request one feature, that's why I think it's a good idea to have a separate bug for that part.

Thanks,

Miklos
Comment 27 bfoman (inactive) 2012-08-24 12:14:57 UTC
*** Bug 54004 has been marked as a duplicate of this bug. ***
Comment 28 bugquestcontri 2012-08-26 01:29:35 UTC
Looking at the release note for Writer 3.7 
https://wiki.documentfoundation.org/ReleaseNotes/3.7#Writer
I was pleased to see the change in colors for consecutive comments. This helps to identify comments and the text range for a comment.

What I am missing so far is that the printout includes the comments at the right side of the text with lines pointing to the text range. Having the comments on the next page with reference to line numbers is not very handy.(I am using LO 3.5.5)

Could the appearance of comments at the right side of a printout be included? I guess quite some LO users would appreciate this.

PS I am writing for the first time here and do not want to change the status below this text box to not a make a mistake and hope that this is not a mistake...
Comment 29 Gerry 2012-10-04 09:02:42 UTC
Am I right that bug 53442 is the follow-up bug aiming to allow comments to several paragraphs as mentioned in comment 25 and 26?

----------


@bugquestcontri@online.de: There is a separate bug for "Advanced printing capabilities of comments in Writer": bug 36815
Please consider voting for improved printing of comments: http://wiki.documentfoundation.org/Vote_for_Enhancement#Bug_36815_-_Advanced_printing_capabilities_of_comments
Comment 30 Alexandre Demers 2012-10-04 13:51:58 UTC
(In reply to comment #29)
> Am I right that bug 53442 is the follow-up bug aiming to allow comments to
> several paragraphs as mentioned in comment 25 and 26?
> 
> ----------
> 
> 
> @bugquestcontri@online.de: There is a separate bug for "Advanced printing
> capabilities of comments in Writer": bug 36815
> Please consider voting for improved printing of comments:
> http://wiki.documentfoundation.org/Vote_for_Enhancement#Bug_36815_-
> _Advanced_printing_capabilities_of_comments

Yes, you are.
Comment 31 OfficeUser 2013-01-17 20:57:41 UTC
Missing support for this feature in doc import and export filters:
https://bugs.freedesktop.org/show_bug.cgi?id=59530
Comment 32 Mikko Ahlroth 2013-01-23 07:11:45 UTC
*** Bug 59743 has been marked as a duplicate of this bug. ***
Comment 33 Jorendc 2013-10-08 10:36:46 UTC
*** Bug 68672 has been marked as a duplicate of this bug. ***
Comment 34 Jon Hayes 2014-02-19 20:59:58 UTC
Created attachment 94383 [details]
This file contains an example of the problem of hidden codes making it hard to edit

This bug is confirmed in version 4.2.0.4. I can only copy and paste from the affected file because it's hard to determine where it happens. It appears to be from one version to another with different users. It also appears to be related to the HIGHLIGHTED block of text for a comment. Examining the XML there is a fieldmark type "" that appears to be the culprit.
Comment 35 Miklos Vajna 2014-02-20 06:42:49 UTC
Please don't reopen bugs without thinking twice.

If you want to improve commented text ranges or want them improved (no idea if the assignment to yourself was intentional or not), then just open a new bug and track it there, since the basic functionality is there.

Also, please try a master daily build: http://dev-builds.libreoffice.org/daily/master/ there we no longer use fieldmarks internally for this feature, that may help your situation.

Thanks! :-)